<template>
    <i-form :model="this.data" class='app-form' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
    <tabs :animated="false" name='form' :value="detailsModel.form.activiedPage" 
        @on-click="detailsModel.form.clickPage($event)">
            <tab-pane v-show="detailsModel.formpage1.visible" name='formpage1' :index="0" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwplistcost.main4_form.details.formpage1')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplistcost.main4_form.details.grouppanel2')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.itemname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='itemname' :itemRules="this.rules.itemname" class='' :caption="$t('entities.emwplistcost.main4_form.details.itemname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.itemname.disabled"
  name='itemname'
  deMajorField='emitemname'
  deKeyField='emitem'
  :service="service"
  :acParams="{ serviceName: 'EMItemService', interfaceName: 'FetchDefault'}"
  valueitem='itemid' 
  :value="data.itemname" 
  editortype="" 
  :pickupView="{ viewname: 'emitempickup-view', title: $t('entities.emitem.views.pickupview.title'), deResParameters: [{ pathName: 'emservices', parameterName: 'emservice' }, ], parameters: [{ pathName: 'emitems', parameterName: 'emitem' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.adate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='adate' :itemRules="this.rules.adate" class='' :caption="$t('entities.emwplistcost.main4_form.details.adate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.adate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="datetime" :transfer="true" format="yyyy-MM-dd HH:mm:ss" placeholder="请选择时间..." :value="data.adate" :disabled="detailsModel.adate.disabled" style="min-width: 150px; width:160px;" @on-change="(val1, val2) => { this.data.adate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.itemdesc.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='itemdesc' :itemRules="this.rules.itemdesc" class='' :caption="$t('entities.emwplistcost.main4_form.details.itemdesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemdesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.itemdesc"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.itemdesc.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.labservicename.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='labservicename' :itemRules="this.rules.labservicename" class='' :caption="$t('entities.emwplistcost.main4_form.details.labservicename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.labservicename.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.labservicename.disabled"
  name='labservicename'
  deMajorField='emservicename'
  deKeyField='emservice'
  :service="service"
  :acParams="{ serviceName: 'EMServiceService', interfaceName: 'FetchDefault'}"
  valueitem='labserviceid' 
  :value="data.labservicename" 
  editortype="" 
  :pickupView="{ viewname: 'emservicepickup-view', title: $t('entities.emservice.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emservices', parameterName: 'emservice' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.listprice.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='listprice' :itemRules="this.rules.listprice" class='' :caption="$t('entities.emwplistcost.main4_form.details.listprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.listprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.listprice"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.listprice.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.discnt.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='discnt' :itemRules="this.rules.discnt" class='' :caption="$t('entities.emwplistcost.main4_form.details.discnt')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.discnt.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.discnt"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.discnt.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.price.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='price' :itemRules="this.rules.price" class='' :caption="$t('entities.emwplistcost.main4_form.details.price')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.price.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.price"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.price.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.taxrate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='taxrate' :itemRules="this.rules.taxrate" class='' :caption="$t('entities.emwplistcost.main4_form.details.taxrate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.taxrate.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.taxrate" :data="data" :itemParam="{}" :disabled="detailsModel.taxrate.disabled"  tag='CADAB38AEA0249DDA40C36287E0E187D' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.pricecdt.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='pricecdt' :itemRules="this.rules.pricecdt" class='' :caption="$t('entities.emwplistcost.main4_form.details.pricecdt')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.pricecdt.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.pricecdt"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.pricecdt.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='unitname' :itemRules="this.rules.unitname" class='' :caption="$t('entities.emwplistcost.main4_form.details.unitname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.unitname.disabled"
  name='unitname'
  deMajorField='pfunitname'
  deKeyField='pfunit'
  :service="service"
  :acParams="{ serviceName: 'PFUnitService', interfaceName: 'FetchDefault'}"
  valueitem='unitid' 
  :value="data.unitname" 
  editortype="" 
  :pickupView="{ viewname: 'pfunitpickup-view', title: $t('entities.pfunit.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfunits', parameterName: 'pfunit' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitdesc.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='unitdesc' :itemRules="this.rules.unitdesc" class='' :caption="$t('entities.emwplistcost.main4_form.details.unitdesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitdesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.unitdesc"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.unitdesc.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitrate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='unitrate' :itemRules="this.rules.unitrate" class='' :caption="$t('entities.emwplistcost.main4_form.details.unitrate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitrate.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.unitrate"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.unitrate.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rempname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.emwplistcost.main4_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rempname.disabled"
  name='rempname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='rempid' 
  :value="data.rempname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.begindate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='begindate' :itemRules="this.rules.begindate" class='' :caption="$t('entities.emwplistcost.main4_form.details.begindate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.begindate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="date" :transfer="true" format="yyyy-MM-dd" placeholder="请选择时间..." :value="data.begindate" :disabled="detailsModel.begindate.disabled" style="min-width: 150px; width:100px;" @on-change="(val1, val2) => { this.data.begindate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.enddate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='enddate' :itemRules="this.rules.enddate" class='' :caption="$t('entities.emwplistcost.main4_form.details.enddate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.enddate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="date" :transfer="true" format="yyyy-MM-dd" placeholder="请选择时间..." :value="data.enddate" :disabled="detailsModel.enddate.disabled" style="min-width: 150px; width:100px;" @on-change="(val1, val2) => { this.data.enddate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.intunitflag.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='intunitflag' :itemRules="this.rules.intunitflag" class='' :caption="$t('entities.emwplistcost.main4_form.details.intunitflag')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.intunitflag.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.intunitflag" :data="data" :itemParam="{}" :disabled="detailsModel.intunitflag.disabled" style="width:100px;width: 100px;" tag='YesNo' codelistType='STATIC'  placeholder='请选择...'></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.sunitprice.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='sunitprice' :itemRules="this.rules.sunitprice" class='' :caption="$t('entities.emwplistcost.main4_form.details.sunitprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.sunitprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='sunitprice'
:value="data.sunitprice" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
            <tab-pane v-show="detailsModel.formpage20.visible" name='formpage20' :index="1" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwplistcost.main4_form.details.formpage20')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel21.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel21.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplistcost.main4_form.details.grouppanel21')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.emwplistcost.main4_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.orgid" :data="data" :itemParam="{}" :disabled="detailsModel.orgid.disabled"  tag='PFCL_ORG' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.emwplistcost.main4_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.description"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.description.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createman' :itemRules="this.rules.createman" class='' :caption="$t('entities.emwplistcost.main4_form.details.createman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createman'
:value="data.createman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createdate' :itemRules="this.rules.createdate" class='' :caption="$t('entities.emwplistcost.main4_form.details.createdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createdate'
:value="data.createdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updateman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updateman' :itemRules="this.rules.updateman" class='' :caption="$t('entities.emwplistcost.main4_form.details.updateman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updateman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updateman'
:value="data.updateman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updatedate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updatedate' :itemRules="this.rules.updatedate" class='' :caption="$t('entities.emwplistcost.main4_form.details.updatedate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updatedate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updatedate'
:value="data.updatedate" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
    </tabs>
    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMWPListCostService from '@/service/emwplist-cost/emwplist-cost-service';
import Main4Service from './main4-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main4Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main4
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main4
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main4
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main4Service}
     * @memberof Main4
     */
    public service: Main4Service = new Main4Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMWPListCostService}
     * @memberof Main4
     */
    public appEntityService: EMWPListCostService = new EMWPListCostService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main4
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main4
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main4
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main4
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main4
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main4
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main4
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main4
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main4
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        itemname: null,
        adate: null,
        itemdesc: null,
        labservicename: null,
        listprice: null,
        discnt: null,
        price: null,
        taxrate: null,
        pricecdt: null,
        unitname: null,
        unitdesc: null,
        unitrate: null,
        rempname: null,
        begindate: null,
        enddate: null,
        intunitflag: null,
        sunitprice: null,
        orgid: null,
        description: null,
        createman: null,
        createdate: null,
        updateman: null,
        updatedate: null,
        unitid: null,
        rempid: null,
        labserviceid: null,
        itemid: null,
        emwplistcostid: null,
        emwplistcost:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main4
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main4
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main4
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main4
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main4
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '询价单标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单标识 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '询价单名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        itemname: [
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'blur' },
        ],
        adate: [
            { type: 'string', message: '询价时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价时间 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '询价时间 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '询价时间 值不能为空', trigger: 'blur' },
        ],
        itemdesc: [
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'blur' },
        ],
        labservicename: [
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'blur' },
        ],
        listprice: [
            { type: 'string', message: '标价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '标价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '标价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '标价 值不能为空', trigger: 'blur' },
        ],
        discnt: [
            { type: 'number', message: '折扣(%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '折扣(%) 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '折扣(%) 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '折扣(%) 值不能为空', trigger: 'blur' },
        ],
        price: [
            { type: 'string', message: '单价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '单价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '单价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '单价 值不能为空', trigger: 'blur' },
        ],
        taxrate: [
            { type: 'number', message: '税率 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '税率 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '税率 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '税率 值不能为空', trigger: 'blur' },
        ],
        pricecdt: [
            { type: 'string', message: '价格条件 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '价格条件 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '价格条件 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '价格条件 值不能为空', trigger: 'blur' },
        ],
        unitname: [
            { type: 'string', message: '询价单位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单位 值不能为空', trigger: 'blur' },
        ],
        unitdesc: [
            { type: 'string', message: '询价单位备注 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单位备注 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单位备注 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单位备注 值不能为空', trigger: 'blur' },
        ],
        unitrate: [
            { type: 'number', message: '单位转换率 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '单位转换率 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '单位转换率 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '单位转换率 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '询价人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价人 值不能为空', trigger: 'blur' },
        ],
        begindate: [
            { type: 'string', message: '有效期起始 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '有效期起始 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '有效期起始 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '有效期起始 值不能为空', trigger: 'blur' },
        ],
        enddate: [
            { type: 'string', message: '有效期截至 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '有效期截至 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '有效期截至 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '有效期截至 值不能为空', trigger: 'blur' },
        ],
        intunitflag: [
            { type: 'number', message: '整单位购买 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '整单位购买 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '整单位购买 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '整单位购买 值不能为空', trigger: 'blur' },
        ],
        sunitprice: [
            { type: 'number', message: '标准单位单价 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '标准单位单价 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '标准单位单价 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '标准单位单价 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
        createman: [
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'blur' },
        ],
        createdate: [
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'blur' },
        ],
        updateman: [
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'blur' },
        ],
        updatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        unitid: [
            { type: 'string', message: '询价单位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单位 值不能为空', trigger: 'blur' },
        ],
        rempid: [
            { type: 'string', message: '询价人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价人 值不能为空', trigger: 'blur' },
        ],
        labserviceid: [
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'blur' },
        ],
        itemid: [
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'blur' },
        ],
        emwplistcostid: [
            { type: 'string', message: '询价单标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价单标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价单标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价单标识 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main4
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '询价单信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplistcost.main4_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        grouppanel21: new FormGroupPanelModel({ caption: '操作信息', detailType: 'GROUPPANEL', name: 'grouppanel21', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplistcost.main4_form', extractMode: 'ITEM', details: [] } })
, 
        formpage20: new FormPageModel({ caption: '其它', detailType: 'FORMPAGE', name: 'formpage20', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '询价单标识', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '询价单名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        itemname: new FormItemModel({ caption: '物品', detailType: 'FORMITEM', name: 'itemname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        adate: new FormItemModel({ caption: '询价时间', detailType: 'FORMITEM', name: 'adate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        itemdesc: new FormItemModel({ caption: '物品备注', detailType: 'FORMITEM', name: 'itemdesc', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        labservicename: new FormItemModel({ caption: '产品供应商', detailType: 'FORMITEM', name: 'labservicename', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        listprice: new FormItemModel({ caption: '标价', detailType: 'FORMITEM', name: 'listprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        discnt: new FormItemModel({ caption: '折扣(%)', detailType: 'FORMITEM', name: 'discnt', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        price: new FormItemModel({ caption: '单价', detailType: 'FORMITEM', name: 'price', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        taxrate: new FormItemModel({ caption: '税率', detailType: 'FORMITEM', name: 'taxrate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        pricecdt: new FormItemModel({ caption: '价格条件', detailType: 'FORMITEM', name: 'pricecdt', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        unitname: new FormItemModel({ caption: '询价单位', detailType: 'FORMITEM', name: 'unitname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        unitdesc: new FormItemModel({ caption: '询价单位备注', detailType: 'FORMITEM', name: 'unitdesc', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        unitrate: new FormItemModel({ caption: '单位转换率', detailType: 'FORMITEM', name: 'unitrate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '询价人', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        begindate: new FormItemModel({ caption: '有效期起始', detailType: 'FORMITEM', name: 'begindate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        enddate: new FormItemModel({ caption: '有效期截至', detailType: 'FORMITEM', name: 'enddate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        intunitflag: new FormItemModel({ caption: '整单位购买', detailType: 'FORMITEM', name: 'intunitflag', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        sunitprice: new FormItemModel({ caption: '标准单位单价', detailType: 'FORMITEM', name: 'sunitprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        createman: new FormItemModel({ caption: '建立人', detailType: 'FORMITEM', name: 'createman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        createdate: new FormItemModel({ caption: '建立时间', detailType: 'FORMITEM', name: 'createdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updateman: new FormItemModel({ caption: '更新人', detailType: 'FORMITEM', name: 'updateman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'updatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        unitid: new FormItemModel({ caption: '询价单位', detailType: 'FORMITEM', name: 'unitid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempid: new FormItemModel({ caption: '询价人', detailType: 'FORMITEM', name: 'rempid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        labserviceid: new FormItemModel({ caption: '产品供应商', detailType: 'FORMITEM', name: 'labserviceid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        itemid: new FormItemModel({ caption: '物品', detailType: 'FORMITEM', name: 'itemid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emwplistcostid: new FormItemModel({ caption: '询价单标识', detailType: 'FORMITEM', name: 'emwplistcostid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        form: new FormTabPanelModel({ caption: 'form', detailType: 'TABPANEL', name: 'form', visible: true, isShowCaption: true, form: this, tabPages: [{ name: 'formpage1', index: 0, visible: true }, { name: 'formpage20', index: 1, visible: true }] }),
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.itemname')
    onItemnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 adate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.adate')
    onAdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'adate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemdesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.itemdesc')
    onItemdescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemdesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 labservicename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.labservicename')
    onLabservicenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'labservicename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 listprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.listprice')
    onListpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'listprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 discnt 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.discnt')
    onDiscntChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'discnt', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 price 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.price')
    onPriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'price', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 taxrate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.taxrate')
    onTaxrateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'taxrate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 pricecdt 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.pricecdt')
    onPricecdtChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'pricecdt', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.unitname')
    onUnitnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitdesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.unitdesc')
    onUnitdescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitdesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitrate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.unitrate')
    onUnitrateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitrate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 begindate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.begindate')
    onBegindateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'begindate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 enddate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.enddate')
    onEnddateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'enddate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 intunitflag 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.intunitflag')
    onIntunitflagChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'intunitflag', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 sunitprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.sunitprice')
    onSunitpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'sunitprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.createman')
    onCreatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.createdate')
    onCreatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updateman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.updateman')
    onUpdatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updateman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.updatedate')
    onUpdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.unitid')
    onUnitidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.rempid')
    onRempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 labserviceid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.labserviceid')
    onLabserviceidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'labserviceid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.itemid')
    onItemidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emwplistcostid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.emwplistcostid')
    onEmwplistcostidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emwplistcostid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                








































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main4
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emwplistcost){
            Object.assign(this.context,{emwplistcost:data.emwplistcost})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main4
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main4
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main4
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main4
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main4
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main4
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main4
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main4
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main4
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main4
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main4
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main4
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main4
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main4
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'询价单<主编辑>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main4
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMWPLISTCOSTEditView9_EditMode视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMWPLISTCOSTEditView9_EditMode视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emwplistcost){
                Object.assign(this.context,{emwplistcost:data.emwplistcost})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMWPLISTCOSTEditView9_EditMode视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMWPLISTCOSTEditView9_EditMode视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMWPLISTCOSTEditView9_EditMode视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emwplistcost || Object.is(arg.emwplistcost, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main4
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main4
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main4
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main4
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main4-form.less';
</style>